# $Revision: 1.23 $, $Date: 2005/01/07 19:17:44 $
#
# Conditional build:
%bcond_without	dist_kernel	# allow non-distribution kernel
%bcond_without	kernel		# don't build kernel modules
%bcond_without	smp		# don't build SMP module
%bcond_without	userspace	# don't build userspace module
%bcond_with	verbose		# verbose build (V=1)
#
# TODO:		- longer descriptions
#		- optional support for: wavfs, cefs, cardfs
#
Summary:	Linux Userland File System - utilities
Summary(pl):	System plikw w przestrzeni uytkownika - narzdzia
Name:		lufs
Version:	0.9.7
%define		_rel	3
Release:	%{_rel}
License:	GPL v2
Group:		Applications/System
Source0:	http://dl.sourceforge.net/lufs/%{name}-%{version}.tar.gz
# Source0-md5:	23f58fe232254a65df6eb4736a81d524
Source1:	%{name}-Makefile
Patch0:		%{name}-fix_install.patch
Patch1:		%{name}-am.patch
URL:		http://lufs.sourceforge.net/lufs/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libtool
%if %{with kernel}
%{?with_dist_kernel:BuildRequires:	kernel-module-build >= 2.6.7}
BuildRequires:	rpmbuild(macros) >= 1.153
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Linux Userland File System - utilities.

%description -l pl
System plikw w przestrzeni uytkownika - narzdzia.

%package devel
Summary:	Linux Userland File System - development files
Summary(pl):	System plikw w przestrzeni uytkownika - pliki dla deweloperw
Group:		Development/Libraries

%description devel
Linux Userland File System - development files.

%description devel -l pl
System plikw w przestrzeni uytkownika - pliki dla deweloperw.

%package -n kernel-fs-lufs
Summary:	Linux Userland File System - kernel module
Summary(pl):	System plikw w przestrzeni uytkownika - modu jdra
Release:	%{_rel}@%{_kernel_ver_str}
Group:		Base/Kernel
%{?with_dist_kernel:%requires_releq_kernel_up}
Requires(post,postun):	/sbin/depmod
%{?with_dist_kernel:Requires(postun):	kernel}
Provides:	kernel-fs(lufs) = %{version}

%description -n kernel-fs-lufs
Linux Userland File System - kernel module.

%description -n kernel-fs-lufs -l pl
System plikw w przestrzeni uytkownika - modu jdra.

%package -n kernel-smp-fs-lufs
Summary:	Linux Userland File System - kernel SMP module
Summary(pl):	System plikw w przestrzeni uytkownika - modu jdra SMP
Release:	%{_rel}@%{_kernel_ver_str}
Group:		Base/Kernel
%{?with_dist_kernel:%requires_releq_kernel_smp}
Requires(post,postun):	/sbin/depmod
%{?with_dist_kernel:Requires(postun):	kernel-smp}

%description -n kernel-smp-fs-lufs
Linux Userland File System - kernel SMP module.

%description -n kernel-smp-fs-lufs -l pl
System plikw w przestrzeni uytkownika - modu jdra SMP.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
%if %{with userspace}
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__automake}
%configure \
	--disable-kernel-support \
	--enable-shared \
	--enable-wavfs
#	--enable-cefs
#	--enable-cardfs

%{__make} -C filesystems
%{__make} -C lufsd
%{__make} -C util
%endif

%if %{with kernel}
cd kernel/Linux/2.6
for cfg in %{?with_dist_kernel:%{?with_smp:smp} up}%{!?with_dist_kernel:nondist}; do
    if [ ! -r "%{_kernelsrcdir}/config-$cfg" ]; then
	exit 1
    fi
    rm -rf include
    install -d include/{linux,config}
    ln -sf %{_kernelsrcdir}/config-$cfg .config
    ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h include/linux/autoconf.h
    ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} include/asm
    touch include/config/MARKER

    install %{SOURCE1} Makefile

    %{__make} -C %{_kernelsrcdir} clean \
	RCS_FIND_IGNORE="-name '*.ko' -o" \
	M=$PWD O=$PWD \
	%{?with_verbose:V=1}
    %{__make} -C %{_kernelsrcdir} modules \
	CC="%{__cc}" CPP="%{__cpp}" \
	M=$PWD O=$PWD \
	%{?with_verbose:V=1}

    mv lufs{,-$cfg}.ko
done
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with userspace}
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT
%endif

%if %{with kernel}
install -d $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}{,smp}/kernel/fs/lufs
cd kernel/Linux/2.6
install lufs-%{?with_dist_kernel:up}%{!?with_dist_kernel:nondist}.ko \
	$RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}/kernel/fs/lufs/lufs.ko
%if %{with smp} && %{with dist_kernel}
install lufs-smp.ko \
	$RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}smp/kernel/fs/lufs/lufs.ko
%endif
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post	-n kernel-fs-lufs
%depmod %{_kernel_ver}

%postun	-n kernel-fs-lufs
%depmod %{_kernel_ver}

%post	-n kernel-smp-fs-lufs
%depmod %{_kernel_ver}smp

%postun	-n kernel-smp-fs-lufs
%depmod %{_kernel_ver}smp

%if %{with userspace}
%files
%defattr(644,root,root,755)
%doc docs/{*.html,*.txt} AUTHORS README THANKS TODO ChangeLog Contributors
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/lufsd.conf
%attr(755,root,root) %{_bindir}/auto.sshfs
%attr(755,root,root) %{_bindir}/auto.ftpfs
%attr(755,root,root) %{_bindir}/lufsd
%attr(755,root,root) %{_bindir}/lufsmount
%attr(755,root,root) %{_bindir}/lussh
# These are SUID root...
%attr(4755,root,root) %{_bindir}/lufsmnt
%attr(4755,root,root) %{_bindir}/lufsumount
#
%attr(755,root,root) %{_libdir}/liblufs-ftpfs.so.*.*.*
%attr(755,root,root) %{_libdir}/liblufs-gnetfs.so.*.*.*
%attr(755,root,root) %{_libdir}/liblufs-localfs.so.*.*.*
%attr(755,root,root) %{_libdir}/liblufs-locasefs.so.*.*.*
%attr(755,root,root) %{_libdir}/liblufs-sshfs.so.*.*.*
%attr(755,root,root) %{_libdir}/liblufs-wavfs.so.*.*.*
%{_mandir}/man1/lufsmount*
%{_mandir}/man1/lufsumount*

%files devel
%defattr(644,root,root,755)
%{_libdir}/liblufs-ftpfs.la
%attr(755,root,root) %{_libdir}/liblufs-ftpfs.so
%{_libdir}/liblufs-gnetfs.la
%attr(755,root,root) %{_libdir}/liblufs-gnetfs.so
%{_libdir}/liblufs-localfs.la
%attr(755,root,root) %{_libdir}/liblufs-localfs.so
%{_libdir}/liblufs-locasefs.la
%attr(755,root,root) %{_libdir}/liblufs-locasefs.so
%{_libdir}/liblufs-sshfs.la
%attr(755,root,root) %{_libdir}/liblufs-sshfs.so
%{_libdir}/liblufs-wavfs.la
%attr(755,root,root) %{_libdir}/liblufs-wavfs.so
%{_includedir}/lufs
%endif

%if %{with kernel}
%files -n kernel-fs-lufs
%defattr(644,root,root,755)
%dir /lib/modules/%{_kernel_ver}/kernel/fs/lufs
/lib/modules/%{_kernel_ver}/kernel/fs/lufs/lufs.ko*

%if %{with smp} && %{with dist_kernel}
%files -n kernel-smp-fs-lufs
%defattr(644,root,root,755)
%dir /lib/modules/%{_kernel_ver}smp/kernel/fs/lufs
/lib/modules/%{_kernel_ver}smp/kernel/fs/lufs/lufs.ko*
%endif
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: lufs.spec,v $
Revision 1.23  2005/01/07 19:17:44  tommat
- wavfs enabled
- rel 3

Revision 1.22  2004/08/09 19:21:53  pluto
- fPIC removed.

Revision 1.21  2004/08/09 19:15:10  pluto
- am fix.

Revision 1.20  2004/08/09 17:29:48  pluto
- fPIC, test build...

Revision 1.19  2004/08/08 10:07:29  pluto
- release 2.

Revision 1.18  2004/08/08 09:52:00  pluto
- %%install, %%files finished.

Revision 1.17  2004/08/08 00:34:03  pluto
- %%build fixed.
- %%install, %%files, %%packages: NFY...

Revision 1.16  2004/02/01 23:59:24  eothane
- bcond, cosmetics

Revision 1.15  2003/11/28 22:34:35  serek
- nev ver.

Revision 1.14  2003/07/10 13:50:48  trojan
- added using depmod macro

Revision 1.13  2003/07/03 14:40:44  qboosh
- standardized sf URLs, other cleanups

Revision 1.12  2003/05/28 12:59:38  malekith
- massive attack: source-md5

Revision 1.11  2003/05/25 05:50:20  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.10  2003/05/16 08:53:05  trojan
- fixed depmod in %%post and %%postun when build with _without_dist_kernel

Revision 1.9  2003/05/14 14:42:44  qboosh
- added depmod options so modules can be installed for kernel other than running

Revision 1.8  2003/05/05 11:26:33  qboosh
- moved *.so symlinks to -devel, cosmetics

Revision 1.7  2003/05/01 14:33:13  mmazur
- updated to 0.9.5 and added -devel subpackage

Revision 1.6  2003/03/29 19:25:41  qboosh
- some cleanups and TODO

Revision 1.5  2003/02/20 18:06:46  mmazur
- dumb thing doesn't work

Revision 1.4  2003/02/20 17:57:22  mmazur
- more work done... yawn

Revision 1.3  2003/02/19 21:23:54  mmazur
- grrr

Revision 1.2  2003/02/19 21:15:29  mmazur
- stupid libs

Revision 1.1  2003/02/19 21:07:12  mmazur
- initial release... hope it works
